Index: src/webapp/sample-code/keyboard-a11y/jquery-ui-tabs/jquery-ui-accessible-tabs.js
===================================================================
--- src/webapp/sample-code/keyboard-a11y/jquery-ui-tabs/jquery-ui-accessible-tabs.js	(revision 5075)
+++ src/webapp/sample-code/keyboard-a11y/jquery-ui-tabs/jquery-ui-accessible-tabs.js	(working copy)
@@ -13,45 +13,49 @@
 
 fluid.accessibleTabs =  function () {
 
-    function activateTabHandler (tabsContainer, tabs) {
-        return function (elementToActivate) {
-            tabsContainer.tabs ('select', tabs.index (elementToActivate));
-        };
-    }
-
     return {
         setupTabs: function (tabsId) {
             jQuery("#" + tabsId).tabs ();
         },
 
         makeTabsKeyNavigable: function (tabsId) {
-            var tabsContainer = jQuery("#" + tabsId);
-            var tabs = tabsContainer.children("li");
+            var tablist = jQuery("#" + tabsId);
+            var tabs = tablist.children("li");
 
-            // Put the tabs container in the tab focus order. Take each tab *out* of the tab order
+            // Put the tablist in the tab focus order. Take each tab *out* of the tab order
             // so that they can be navigated with the arrow keys instead of the tab key.
-            tabsContainer.tabbable ();
+            tablist.tabbable ();
 
             // Make the tabs selectable:
             //  * Pass in the container for the tabs (the <ul>)--the plugin binds keyboard handlers to this.
-            //  * null because we don't want to have any special callbacks during selection
+            //  * utilize option willSelect: to make the tab actually selected.
             //  * lastly, the options object allows to simply specify the direction (which defaults to vertical)
-            tabs.selectable (tabsContainer, null, {direction: jQuery.a11y.orientation.HORIZONTAL});
-
-            // Make the tabs activatable. Pass in a handler that just calls the standard tabs select function.
-            tabs.activatable (activateTabHandler (tabsContainer, tabs));
+            tabs.selectable (tablist, 
+            	{willSelect: 
+            		function (elem) {
+            			tablist.ariaState ("activedescendant", elem.id); // todo: move to common mouse/key event point
+            			tablist.tabs ('select', tabs.index (elem));
+            		}
+            	},
+            	{direction: jQuery.a11y.orientation.HORIZONTAL});
         },
 
         addARIA: function (tabsId, panelsId) {
-            var tabsContainer = jQuery ("#" + tabsId);
-            var tabs = tabsContainer.children ("li");
+			var tablist = jQuery ("#" + tabsId).tabs();
+			var tabs = tablist.children ("li");
             var panels = jQuery ("#" + "panels > div");
 
-            tabsContainer.ariaRole ("tablist");
-            tabs.ariaRole ("tab");
+            tablist.ariaRole ("tablist");
+            tabs.each (function (i,tab) {
+            	jQuery (tab).ariaRole ("tab").ariaState ("posinset", i);
+            });
+
             panels.ariaRole ("tabpanel");
-
-            // need to add labelledby properties
+			panels.each (function (i,tab) {
+				jQuery (tab).ariaState ("posinset", i).ariaState ("labelledby", tab.id.split("Panel")[0] + "Tab");
+			});
+			
+			// see makeTabsKeyNavigable for activedescendant role
         },
 
         initializeTabs: function (tabsId, panelsId) {
